//+------------------------------------------------------------------+

#property link      "www.forex-tsd.com"  
#property copyright "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  clrLimeGreen
#property indicator_color2  clrRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1
#property strict

//
//
//
//
//

enum enTimeFrames
{
   tf_cu  = 0,              // Current time frame
   tf_m1  = PERIOD_M1,      // 1 minute
   tf_m5  = PERIOD_M5,      // 5 minutes
   tf_m15 = PERIOD_M15,     // 15 minutes
   tf_m30 = PERIOD_M30,     // 30 minutes
   tf_h1  = PERIOD_H1,      // 1 hour
   tf_h4  = PERIOD_H4,      // 4 hours
   tf_d1  = PERIOD_D1,      // Daily
   tf_w1  = PERIOD_W1,      // Weekly
   tf_mb1 = PERIOD_MN1,     // Monthly
   tf_cus = 12345678        // Custom time frame
};

extern enTimeFrames       TimeFrame       = tf_cu;     // Time frame
extern int                TimeFrameCustom = 0;         // Custom time frame to use (if custom time frame used)
extern int                RsiPeriod       = 14;        // Rsi Period
extern ENUM_APPLIED_PRICE Price           = 0;         // Rsi Price
extern int                MaPeriod        = 7;         // Rsi Ma Period
extern ENUM_MA_METHOD     MaMode          = MODE_LWMA; // Rsi Ma Mode

//
//
//
//
//

double rsi[];
double rsiDa[];
double rsiDb[];
double rsiMa[];
double trend[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(5); 
   SetIndexBuffer(0,rsiDa); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,rsiDb); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,rsi); 
   SetIndexBuffer(3,rsiMa); 
   SetIndexBuffer(4,trend); 
   
     //
     //
     //
     //
     //
   
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99; 
         if (TimeFrameCustom==0) TimeFrameCustom = MathMax(TimeFrameCustom,_Period);
         if (TimeFrame!=tf_cus)
               TimeFrame = MathMax(TimeFrame,_Period);
         else  TimeFrame = (enTimeFrames)TimeFrameCustom;
      
    //
    //
    //
    //
    //      

    IndicatorShortName(timeFrameToString(TimeFrame)+" Rsi Ma Histo("+(string)RsiPeriod+","+(string)MaPeriod+")");
return(0);
}
int deinit() 
{
return(0); 
}

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1); 
           if (returnBars) { rsiDa[0] = MathMin(limit+1,Bars-1); return(0); }
   
   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {     
     for(i=limit; i >= 0; i--) rsi[i] = iRsi(iMA(NULL,0,1,0,MODE_SMA,Price,i),RsiPeriod,i);
     for(i=limit; i >= 0; i--)
     {
        rsiMa[i] = iMAOnArray(rsi,0,MaPeriod,0,MaMode,i);
        rsiDa[i] = EMPTY_VALUE;
        rsiDb[i] = EMPTY_VALUE;
        if (i<Bars-1)
        {
           trend[i] = trend[i+1];
           if (rsi[i]>rsiMa[i]) trend[i] = 1;
           if (rsi[i]<rsiMa[i]) trend[i] =-1;
           if (trend[i] == 1)   rsiDa[i] = 1;
           if (trend[i] ==-1)   rsiDb[i] = 1;
         } 
     }  
   return(0);           
   }
   
   //
   //
   //
   //
   //
   
   limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for(i=limit; i >= 0; i--)  
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         rsiDa[i] = iCustom(NULL,TimeFrame,indicatorFileName,tf_cu,0,RsiPeriod,Price,MaPeriod,MaMode,0,y);
         rsiDb[i] = iCustom(NULL,TimeFrame,indicatorFileName,tf_cu,0,RsiPeriod,Price,MaPeriod,MaMode,1,y);     
   }
return(0);
}
    
//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

double workRsi[][3];
#define _price  0
#define _change 1
#define _changa 2

//
//
//
//

double iRsi(double price, double period, int shift, int forz=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int    z     = forz*3; 
      int    i     = Bars-shift-1;
      double alpha = 1.0/period; 

   //
   //
   //
   //
   //
   
   workRsi[i][_price+z] = price;
   if (i<period)
      {
         int k; double sum = 0; for (k=0; k<period && (i-k-1)>=0; k++) sum += MathAbs(workRsi[i-k][_price+z]-workRsi[i-k-1][_price+z]);
            workRsi[i][_change+z] = (workRsi[i][_price+z]-workRsi[0][_price+z])/MathMax(k,1);
            workRsi[i][_changa+z] =                                         sum/MathMax(k,1);
      }
   else
      {
         double change = workRsi[i][_price+z]-workRsi[i-1][_price+z];
                         workRsi[i][_change+z] = workRsi[i-1][_change+z] + alpha*(        change  - workRsi[i-1][_change+z]);
                         workRsi[i][_changa+z] = workRsi[i-1][_changa+z] + alpha*(MathAbs(change) - workRsi[i-1][_changa+z]);
      }
   if (workRsi[i][_changa+z] != 0)
         return(50.0*(workRsi[i][_change+z]/workRsi[i][_changa+z]+1));
   else  return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}